<script lang="ts">
  import { onMount } from "svelte";
  import { inputPattern } from "src/functions/input-pattern";
  import type { ProductModel } from "src/models/product.type";
  import AlertConfirm from "src/widgets/AlertConfirm";
  import AlertMessage from "src/widgets/AlertMessage";
  import Pagination from "src/widgets/Pagination.svelte";
  import {
    formViewMode,
    pageSelectedStore,
    productListStore,
    productSelectedStore,
  } from "src/store";
  import Fa from "svelte-fa";
  import { faEdit, faSearch, faTrash } from "@fortawesome/free-solid-svg-icons";
  import { Page } from "src/page";
  import { deleteUserProfileAPI } from "src/apis/delete-user-profile";
  import { getProductsAPI } from "src/apis/get-products";
import { deleteProductAPI } from "src/apis/delete-product";
  let usersProfilePagination: ProductModel[] = [];

  let keyWord = "";
  let respSearch: ProductModel[] = [];
  let addressFindText = "";
  let searchPattern: any = {
    [`รหัสสินค้า`]: "productId",
    [`ชื่อสินค้า`]: "productName"
  };

  let searchBy = "รหัสสินค้า";
  let dataShowOnTable: ProductModel[] = [];

  onMount(async () => {
    await getProductsAPI();
  });

  $: {
    dataShowOnTable =
      respSearch.length && (keyWord || addressFindText)
        ? respSearch
        : keyWord == "" && addressFindText == ""
        ? usersProfilePagination
        : [];
  }

  function editItem(objProfile: ProductModel) {
    AlertConfirm.alert(
      "<p class='font-medium'>ต้องการแก้ไขข้อมูล " +
        objProfile.productName +
        " ใช่ไหม? </p>"
    ).then((resp) => {
      if (resp == "confirm") {
        $formViewMode = false;
        $productSelectedStore = objProfile;
        $pageSelectedStore = Page["PRODUCT_MANAGE"];
      }
    });
  }

  function viewItem(objProfile: ProductModel) {
    $productSelectedStore = objProfile;
    $pageSelectedStore = Page["PRODUCT_MANAGE"];
    $formViewMode = true;
  }

  function deleteItem(uuid: string) {
    if (uuid) {
      AlertConfirm.alert(
        `<p class="text-red-500"> ต้องการลบข้อมูลใช่หรือไม่ </p>`
      ).then((result) => {
        if (result == "confirm") {
          deleteProductAPI(uuid)
            .then((resp) => {
              AlertMessage.alert("คุณได้ลบข้อมูลเรียบร้อยแล้ว").then(
                async (resp) => {
                  await getProductsAPI();
                }
              );
            })
            .catch((err) => {
              AlertMessage.alert(
                `<p class="text-red-500">ผิดพลาดในการลบข้อมูล </p>`
              );
            });
        }
      });
    }
  }

  function findDataArray() {
    if (keyWord) {
      keyWord = keyWord.replace(/\\/g, "");
      let regex = new RegExp(keyWord, "g");
      respSearch = $productListStore.filter((dt: any) => {
        console.log(searchPattern[searchBy]);
        if (dt[searchPattern[searchBy]]) {
          return dt[searchPattern[searchBy]].match(regex);
        }
      });
    } else {
      respSearch = [];
    }
  }
</script>

<div class="rounded h-full m-4">
  {#if $productListStore.length > 0}
    <div id="tools" class="bg-gray-800 p-2 rounded">
      <div class="flex flex-wrap -mx-3 mb-2 justify-end items-center">
        <p class="text-white">ค้นหาโดย :</p>
        <div class="w-full md:w-1/6 px-3 mb-6 md:mb-0">
          <div class="">
            <select
              bind:value={searchBy}
              class="block w-full bg-gray-200 border
                border-gray-200 text-gray-700 py-3 px-4 pr-8 rounded leading-tight
                focus:outline-none focus:bg-white focus:border-gray-500"
              id="grid-state"
            >
              {#each Object.keys(searchPattern) as k}
                <option>{k}</option>
              {/each}
            </select>
          </div>
        </div>

        <div class="w-full md:w-3/6 px-3 mb-6 md:mb-0">
          <input
            bind:value={keyWord}
            on:keyup={() => findDataArray()}
            placeholder="ค้นหา"
            class="appearance-none block w-full py-3 px-4 leading-tight
              text-gray-700 bg-gray-200 focus:bg-white border border-gray-200
              focus:border-gray-500 rounded focus:outline-none pac-target-input"
          />
        </div>
      </div>
      {#if respSearch.length == 0 && (keyWord || addressFindText)}
        <p class="text-right px-2 text-red-500">* ไม่พบรายการบนฐานข้อมูล</p>
      {/if}
    </div>
    <div class="block w-full overflow-x-auto">
      <table
        class="table-auto w-full overflow-y-auto overflow-x-auto border rounded"
      >
        <thead class="bg-gray-100">
          <tr>
            <th class="px-4 py-2">#</th>
            <th class="px-4 py-2">รูป</th>
            <th class="px-4 py-2">รหัส</th>
            <th class="px-4 py-2">ชื่อ</th>
            <th class="px-4 py-2">ราคา</th>
            <th class="px-4 py-2">ส่วนลด</th>
            <th class="px-4 py-2">เบอร์ติดต่อ</th>
            <th class="px-4 py-2">เครื่องมือ</th>
          </tr>
        </thead>
        {#each dataShowOnTable as product, index}
          <tbody>
            <tr
              class="bg-gray-100 hover:bg-gray-200"
            >
              <td class="border px-2 py-2 text-gray-800">{index + 1}</td>
              <td class="border px-2 py-2 text-gray-800 flex justify-center items-center">
                <img alt="..." class="w-16 h-16 border-2 border-gray-400 rounded-full" src={product.image[0].url}>
              </td>
              <td class="border px-2 py-2 text-gray-800">{product.productId}</td>
              <td class="border px-2 py-2 text-gray-800">{product.productName}</td>
              <td class="border px-2 py-2 overflow-x-hidden text-gray-800">
                {product.productName || "-"}
              </td>
              <td class="border px-2 py-2 text-gray-800">
                {product.productName || "-"}
              </td>
              <td class="border px-2 py-2 text-gray-800">
                {product.productName || "-"}
              </td>
              <td
                class="border px-2 py-2 text-gray-800"
              >
                <div class="flex justify-center">
                    <div class="flex h-full"
                  on:click={() => {
                    deleteItem(product.uuid || "");
                  }}
                >
                  <Fa
                    icon={faTrash}
                    fw
                    size="lg"
                    class="cursor-pointer text-red-500 hover:text-gray-500 fa fa-trash px-1"
                  />
                </div>

                <p class="px-3" />

                <div class="flex h-full"
                  on:click={() => {
                    editItem(product);
                  }}
                >
                  <Fa
                    icon={faEdit}
                    fw
                    size="lg"
                    class="cursor-pointer text-yellow-500 hover:text-gray-500 fa fa-trash px-1"
                  />
                </div>

                <p class="px-2" />

                <div class="flex h-full"
                  on:click={() => {
                    viewItem(product);
                  }}
                >
                  <Fa
                    icon={faSearch}
                    fw
                    size="lg"
                    class="cursor-pointer text-blue-500 hover:text-gray-500 fa fa-trash px-1"
                  />
                </div>
                </div>
              </td>
            </tr>
          </tbody>
        {/each}
      </table>
    </div>
    <Pagination
      maxItemPerPage={10}
      bind:items={$productListStore}
      bind:pageItemsCurrent={usersProfilePagination}
    />
  {:else}
    <div class="h-full flex justify-center items-center">
      <p class="text-gray-500 text-xl text-right">
        ไม่พบรายการบนฐานข้อมูล
        <br />
        กรุณาเพิ่มข้อมูลสินค้าก่อน
      </p>
    </div>
  {/if}
</div>
